% pwt91read.m    August 2020
%
%   Read the pwt91 data set using the Matlab readtable command to
%   read xlsx files 
%
clear all; close all;
diarychad('pwt91read');

% Name of the Excel file to read
fname='pwt91.xlsx'; 

% Read the Dictionary (Legend) describing the variables and display it
Dictionary=readtable(fname,'Sheet','Legend')

% Read the xlsx file
pwtdata=readtable(fname,'Sheet','Data');
s=summary(pwtdata)
varnames=fieldnames(s);
s.year
years=(s.year.Min:s.year.Max)';
NumYears     = length(years)
NumCountries = length(pwtdata.year)/NumYears

% Restructure each variables as a matrix with dimension: NumYears x NumCountries
for i=1:length(varnames);
  eval([varnames{i} '=reshape(pwtdata.' varnames{i} ',NumYears,NumCountries);']);
end;

% Assign names and codes to NumCountries x 1 vectors
names=country(1,:)';
codes=countrycode(1,:)';

% Create three-letter codes that point to the appropriate column for
% each country. E.g. ARG=6 and USA=173
for i=1:length(codes);
  eval([codes{i} '=i;']);
end;
names{ARG}
names{USA}

clear varnames countrycode country year s i 

[names codes]
save pwt91


diary off;
